﻿#version 330 core

in vec2 texCoord;
in vec3 vPosWorld;
in vec3 normalCamera;
in vec3 eyeDirCamera;
in vec3 lightDirCamera;

out vec3 color;

uniform sampler2D diffTexture;
uniform vec3 lightPosWorld;

void main()
{
	vec3 lightColor = vec3(1, 1, 1);
	float lightPower = 70.0f;

	vec3 matDiffColor = texture(diffTexture, texCoord).rgb;
	vec3 matAmbColor = vec3(0.1, 0.1, 0.1) * matDiffColor;
	vec3 matSpecColor = vec3(0.3, 0.3, 0.3);

	float distance = length(lightPosWorld - vPosWorld);

	vec3 n = normalize(normalCamera);
	vec3 l = normalize(lightDirCamera);
	float cosTheta = clamp(dot(n, l), 0, 1);

	vec3 e = normalize(eyeDirCamera);
	vec3 r = reflect(-l, n);
	float cosAlpha = clamp(dot(e, r), 0, 1);

	color = matAmbColor +
		matDiffColor * lightColor * lightPower * cosTheta / (distance*distance) +
		matSpecColor * lightColor * lightPower * pow(cosAlpha, 5) / (distance*distance);

}
