﻿#version 330 core

layout(location = 0) in vec3 vPosLocal;
layout(location = 1) in vec3 vNormal;
layout(location = 2) in vec2 vTexCoord;

out vec2 texCoord;
out vec3 vPosWorld;
out vec3 normalCamera;
out vec3 eyeDirCamera;
out vec3 lightDirCamera;

uniform mat4 mvp;
uniform mat4 m;
uniform mat4 v;
uniform vec3 lightPosWorld;

void main()
{
	gl_Position = mvp * vec4(vPosLocal, 1);

	vPosWorld = (m * vec4(vPosLocal, 1)).xyz;

	vec3 vPosCamera = (v * m * vec4(vPosLocal, 1)).xyz;
	eyeDirCamera = vec3(0, 0, 0) - vPosCamera;

	vec3 lightPosCamera = (v * vec4(lightPosWorld, 1)).xyz;
	lightDirCamera = lightPosCamera + eyeDirCamera;

	normalCamera = (v * m * vec4(vNormal, 0)).xyz;

	texCoord = vTexCoord;
}

